/* GCC */

#include <fstream>
#include <algorithm>
#include <vector>
#define INF 1000000000L

using namespace std;

int N, M;
pair<int, int> ToConnect[500];

vector<int> GR, LR, LLR, r;
long GV, LV, LLV, v;

inline long f(const vector<int> &a)
{
       long res = 0;
       for(int i = 0; i < M; i++)
       {
               res += abs(a[ToConnect[i].first] - a[ToConnect[i].second]);
       }
       return res;
}

int main()
{
    ifstream fin("servers.in");
    fin>>N>>M;
    for(int i = 0; i < M; i++)
        fin>>ToConnect[i].first>>ToConnect[i].second, ToConnect[i].first--, ToConnect[i].second--;
    fin.close();
        
    vector<int> Range(N);
    for(int i = 0; i < N; i++)
        Range[i] = i;
        
    GV = INF;
    
    for(int t = 0; t < 250; t++)
    {
        random_shuffle(Range.begin(), Range.end());
     
        LV = INF;
        LR = Range;
           
        while(true)
        {
             LLV = INF;
             
             for(int i = 0; i < N; i++)
                for(int j = i+1; j < N; j++)
                {
                    r = LR;
                    swap(r[i], r[j]);
                    v = f(r);
                    if(v < LLV)
                    {
                        LLR = r;
                        LLV = v;
                    }
                }
             
             if(LV == LLV)
                   break;
                   
             LR = LLR;
             LV = LLV;
        }     
        
        if(LV < GV)
        {
             GV = LV;
             GR = LR;      
        }  
    }
    
    vector<int> answers(N);
    
    for(int i = 0; i < N; i++)
       answers[GR[i]] = i;
    
    ofstream fout("servers.out");
    fout<<GV<<endl;
    fout<<answers[0]+1;
    for(int i = 1; i < N; i++)
        fout<<' '<<answers[i]+1;
    fout<<endl;
    fout.close();
    
    return 0;
}
